C This helps to determine systematic absences due to lattice type
C
C JTYPE defines the lattice type (face-centered cubic etc.)
C       JTYPE=1 is for primitive
C       JTYPE=2 is for body-centered
C       JTYPE=3 is for face-centered
C       JTYPE=4 is for A-centered
C       JTYPE=5 is for B-centered
C       JTYPE=6 is for C-centered
C Reference: "Essentials of Crystallography"
C            by D. McKie and C. McKie, Blackwell Scientific Publ.
C            London, 1986, page 197
C
C
      SUBROUTINE MAP_CRYSTAL_TYPE(H,K,L,JTYPE,JLOG)
      IMPLICIT NONE
      REAL H,K,L,A
      INTEGER JTYPE,JLOG,JODD,J1,J2,J3
C
C
        IF(JTYPE .EQ. 1)GOTO 2
        IF(JTYPE .EQ. 2)GOTO 3
        IF(JTYPE .EQ. 3)GOTO 4
        IF(JTYPE .EQ. 4)GOTO 5
        IF(JTYPE .EQ. 5)GOTO 6
        IF(JTYPE .EQ. 6)GOTO 8
C
C Now check for systematic absences
C  and set JLOG=0 if the HKL is not absent, 1 if absent
C
3     A=H+K+L
        CALL MAP_UTIL_ODD(A,JODD)
        IF(JODD .EQ. 1)GOTO 7
      GOTO 2
C
4        CALL MAP_UTIL_ODD(H,J1)
         CALL MAP_UTIL_ODD(K,J2)
         CALL MAP_UTIL_ODD(L,J3)
        IF(J1 .EQ. 0 .AND. J2 .EQ. 0 .AND. J3 .EQ. 0) GOTO 2
        IF(J1 .EQ. 1 .AND. J2 .EQ. 1 .AND. J3 .EQ. 1) GOTO 2
      GOTO 7
C
5     A=K+L
        CALL MAP_UTIL_ODD(A,JODD)
        IF(JODD .EQ. 1)GOTO 7
      GOTO 2
C
6     A=H+L
        CALL MAP_UTIL_ODD(A,JODD)
        IF(JODD .EQ. 1) GOTO 7
      GOTO 2
C
8     A=H+K
        CALL MAP_UTIL_ODD(A,JODD)
        IF(JODD .EQ. 1) GOTO 7
      GOTO 2
C
7     JLOG=1
        GOTO 9
2     JLOG=0
C
9       RETURN
        END
